Imports ATSMS
Imports ATSMS.SMS

Public Class MainForm

    Private Const PHONE_BOOK As String = "phonebook.txt"

    Private m_strPhoneBook As String

    Private WithEvents oGsmModem As New GSMModem

    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click
        If cboComPort.Text = String.Empty Then
            MsgBox("COM Port must be selected", MsgBoxStyle.Information)
            Return
        End If

        oGsmModem.Port = cboComPort.Text

        If cboBaudRate.Text <> String.Empty Then
            oGsmModem.BaudRate = Convert.ToInt32(cboBaudRate.Text)
        End If

        If cboDataBit.Text <> String.Empty Then
            oGsmModem.DataBits = Convert.ToInt32(cboDataBit.Text)
        End If

        If cboStopBit.Text <> String.Empty Then
            Select Case cboStopBit.Text
                Case "1"
                    oGsmModem.StopBits = Common.EnumStopBits.One
                Case "1.5"
                    oGsmModem.StopBits = Common.EnumStopBits.OnePointFive
                Case "2"
                    oGsmModem.StopBits = Common.EnumStopBits.Two
            End Select
        End If

        If cboFlowControl.Text <> String.Empty Then
            Select Case cboFlowControl.Text
                Case "None"
                    oGsmModem.FlowControl = Common.EnumFlowControl.None
                Case "Hardware"
                    oGsmModem.FlowControl = Common.EnumFlowControl.RTS_CTS
                Case "Xon/Xoff"
                    oGsmModem.FlowControl = Common.EnumFlowControl.Xon_Xoff
            End Select
        End If

        Try
            oGsmModem.Connect()
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Critical)
            Return
        End Try

        Try
            oGsmModem.NewMessageIndication = True
        Catch ex As Exception

        End Try

        btnSend.Enabled = True
        btnDisconnect.Enabled = True
        btnConnect.Enabled = False

        oGsmModem.AutoDeleteSentMessage = True
        MsgBox("Connected to phone successfully !", MsgBoxStyle.Information)
    End Sub

    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        CheckForIllegalCrossThreadCalls = False

        Initialize()
    End Sub

    Private Sub btnDisconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDisconnect.Click
        Try
            oGsmModem.Disconnect()
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Critical)
        End Try

        btnSend.Enabled = False
        btnDisconnect.Enabled = False
        btnConnect.Enabled = True
    End Sub

   
    Private Sub btnAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAdd.Click
        Dim msisdn As String = InputBox("Enter a valid phone number", "Bulk SMS Gateway")
        If msisdn <> String.Empty Then
            lstPhoneList.Items.Add(msisdn)
            SavePhoneBook()
        End If

    End Sub

    Private Sub btnRemove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRemove.Click
        lstPhoneList.Items.Remove(lstPhoneList.SelectedItem)
        SavePhoneBook()
    End Sub

    Private Sub Initialize()
        ' Read from the phone book
        Dim strContent As String
        m_strPhoneBook = Application.StartupPath & "\" & PHONE_BOOK
        If My.Computer.FileSystem.FileExists(m_strPhoneBook) Then
            strContent = My.Computer.FileSystem.ReadAllText(m_strPhoneBook)
            Dim lines() As String = strContent.Split(ControlChars.CrLf)
            Dim i As Integer
            For i = 0 To lines.Length - 1
                lstPhoneList.Items.Add(lines(i))
            Next
        End If
    End Sub

    Private Sub SavePhoneBook()
        Dim strFileContent As String = String.Empty
        For Each item As String In lstPhoneList.Items
            strFileContent += item & ControlChars.CrLf
        Next
        My.Computer.FileSystem.WriteAllText(m_strPhoneBook, strFileContent, False)
        'MsgBox("Saved !", MsgBoxStyle.Information)
    End Sub

    Private Sub btnSend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSend.Click
        If txtMsg.Text.Trim = String.Empty Then
            MsgBox("Message must not be empty !", MsgBoxStyle.Information)
            Return
        End If

        If StringUtils.IsUnicode(txtMsg.Text) Then
            oGsmModem.Encoding = Common.EnumEncoding.Unicode_16Bit
        Else
            oGsmModem.Encoding = Common.EnumEncoding.GSM_Default_7Bit
        End If

        For Each item As String In lstPhoneList.Items
            If item.Trim <> String.Empty Then
                oGsmModem.SendSMSToOutbox(item.Trim, txtMsg.Text.Trim)
            End If
        Next

        MsgBox("Message is queued for sending !", MsgBoxStyle.Information)
    End Sub

    Private Sub oGsmModem_OutboxSMSSent(ByVal e As ATSMS.OutboxSMSSentEventArgs) Handles oGsmModem.OutboxSMSSent
        If e.ErrorCode > 0 Then
            txtMsgDeliveryStatus.Text += "Error sending message to " & e.DestinationNumber & ". " & e.ErrorDescription & ControlChars.CrLf
        Else
            txtMsgDeliveryStatus.Text += "Message is delivered to " & e.DestinationNumber & ControlChars.CrLf
        End If
    End Sub
End Class
